/************************************************************************
 *									*
 *		nr^Q@IC[UT|[gVXe		*
 *			ob|mds^Q				*
 *									*
 *				: f[^x[X			*
 *		t@C	: isam.c				*
 *		쐬		: s.aizawa				*
 *									*
 ************************************************************************/

#include "pcnet.h"
#include <stdlib.h>
#include <memory.h>
#include <string.h>
#include <time.h>
#include <io.h>
#include <fcntl.h>
#include <sys\types.h>
#include <sys\stat.h>

#define	MBLOCK	8192
#define	SBLOCK	(USHORT)(MBLOCK*3)

typedef	struct	{
	LONG	nRec;
	LONG	offset;
} SORTBLK;

/*--------------------------------------*/
/*		֐		*/
/*--------------------------------------*/
static	VOID	SkipDeleted(DB *, SHORT);
static	VOID	Skip(DB *, LONG);
static	VOID	CheckBof(DB *, LONG);
static	VOID	CheckEof(DB *, LONG);
static	VOID	memcpyr(CHAR *, CHAR *, SHORT);
static	USHORT	Marge(int, int, SORTBLK *, SORTBLK *, CHAR *, USHORT, SHORT (*)(CHAR *, CHAR *));
static	SHORT	Comp2(CHAR *, CHAR *);
static	VOID	WrtIndex(IDX *, int, LONG, SHORT);
static	VOID	WrtBlock(IDX *, int, SHORT, SHORT, CHAR *, LONG *);
static	VOID	SetExt(CHAR *, CHAR *);

/*--------------------------------------*/
/*		ϐ		*/
/*--------------------------------------*/
static	DB	*_dbTopPtr = 0;	/* f[^x[X擪|C^ */
static	VOID	(*_dbErrHandler)(SHORT) = 0;	/* G[֐|C^ */
static	SHORT	compLength;
static	LONG	wnRec, wBno;
static	BOOL	_dbSetDeleted = FALSE;	/* 폜R[htO */

/*--------------------------------------*/
/*		Oϐ		*/
/*--------------------------------------*/
SHORT	_dbErrCode;			/* G[R[h */

/*=======================================================================
 |
 |		f[^x[XI[v
 |
 |	DB	*DBOpen(fileName)
 |
 |		CHAR	*fileName;	f[^t@C
 |
 |		Ԓl			ca|C^
 |
 =======================================================================*/
DB	*DBOpen(CHAR *fileName)
{
	DB	*dbp;

	/* f[^x[XǗGAm */
	if ((dbp = malloc(sizeof(DB))) == NULL) {
		DBErr(IE_MEMORY);
		return(NULL);
	}
	memset(dbp, 0, sizeof(DB));
	dbp->sem.cb = 14;

	/* f[^t@CicaejI[v */
	if ((dbp->dp = DBFOpen(fileName)) == NULL) {
		DBClose(dbp);
		return(NULL);
	}

	CheckBof(dbp, 1L);	/* ane`FbN*/

	/* `FC */
	dbp->chain = _dbTopPtr;
	_dbTopPtr = dbp;

	return(dbp);
}

/*=======================================================================
 |
 |		f[^x[X쐬
 |
 |	DB	*DBCreate(fileName, dip, nField)
 |
 |		CHAR	*fileName;	f[^t@C
 |		DBF_I	*dip;		f[^t@C
 |		SHORT	nField;		tB[h
 |
 |		Ԓl			ca|C^
 |
 =======================================================================*/
DB	*DBCreate(CHAR *fileName, DBF_I *dip, SHORT nField)
{
	DBF	*dp;

	/* f[^t@C쐬 */
	if ((dp = DBFCreate(fileName, dip, nField)) == NULL)
		return(NULL);

	DBFClose(dp);	/* f[^t@CN[Y */

	return(DBOpen(fileName));
}

/*=======================================================================
 |
 |		f[^x[XN[Y
 |
 |	VOID	DBClose(dbp)
 |
 |		DB	*dbp;		ca|C^
 |
 =======================================================================*/
VOID	DBClose(DB *dbp)
{
	DB	**dbpp;
	USHORT	i;

	/* f[^t@CN[Y */
	if (dbp->dp != NULL)
		DBFClose(dbp->dp);

	/* CfbNXt@CN[Y */
	for (i = 1; i <= dbp->nIdx; i++) {
		if (dbp->ip[i] != NULL)
			IDXClose(dbp->ip[i]);
	}

	/* `FC؂藣 */
	for (dbpp = &_dbTopPtr; *dbpp != 0; dbpp = &(*dbpp)->chain) {
		if ((*dbpp) == dbp) {
			*dbpp = (*dbpp)->chain;
			break;
		}
	}

	free(dbp);	/* ǗGA */
}

/*=======================================================================
 |
 |		Sf[^x[XN[Y
 |
 |	VOID	DBCloseAll()
 |
 =======================================================================*/
VOID	DBCloseAll()
{
	while (_dbTopPtr != NULL)
		DBClose(_dbTopPtr);
}

/*=======================================================================
 |
 |		t@C|o
 |
 |	VOID	DBFlush(dbp)
 |
 |		DB	*dbp;		ca|C^
 |
 =======================================================================*/
VOID	DBFlush(DB *dbp)
{
	USHORT	i;

	DBFFlush(dbp->dp);	/* f[^t@CtbV */

	/* CfbNXt@CtbV */
	for (i = 1; i <= dbp->nIdx; i++) {
		if (dbp->ip[i] != NULL)
			IDXFlush(dbp->ip[i]);
	}
}

/*=======================================================================
 |
 |		St@C|o
 |
 |	VOID	DBFlushAll()
 |
 =======================================================================*/
VOID	DBFlushAll()
{
	DB	*dbp;

	for (dbp = _dbTopPtr; dbp != NULL; dbp = dbp->chain) {
		DBLock(dbp);
		DBFlush(dbp);
		DBRelease(dbp);
	}
}

/*=======================================================================
 |
 |		CfbNXt@CI[v
 |
 |	SHORT	DBIndex(dbp, fileName)
 |
 |		DB	*dbp;		ca|C^
 |		CHAR	*fileName;	CfbNXt@C
 |
 |		Ԓl			CfbNXt@Cԍ
 |
 =======================================================================*/
SHORT	DBIndex(DB *dbp, CHAR *fileName)
{
	/* CfbNXt@CI[v`FbN */
	if (dbp->nIdx >= MAX_IDX) {
		DBErr(IE_IDXOVER);
		return(0);
	}

	/* CfbNXt@CI[v */
	if ((dbp->ip[dbp->nIdx+1] = IDXOpen(fileName)) == NULL)
		return(0);


	dbp->nIdx++;		/* CfbNXt@CXV */

	/* }X^[CfbNXt@CԍZbg */
	if (dbp->master == 0) {
		dbp->master = dbp->nIdx;
		DBTop(dbp);
	}

	return(dbp->nIdx);
}

/*=======================================================================
 |
 |		CfbNXt@C쐬
 |
 |	SHORT	DBIdxCreate(dbp, fileName, key, uniq)
 |
 |		DB	*dbp;		ca|C^
 |		CHAR	*fileName;	CfbNXt@C
 |		CHAR	*key;		L[
 |		SHORT	uniq;		OFL[̏d@PFȂ
 |
 |		Ԓl			CfbNXt@Cԍ
 |
 =======================================================================*/
SHORT	DBIdxCreate(DB *dbp, CHAR *fileName, CHAR *key, SHORT uniq)
{
	DBF	*dp;
	IDX	*ip;

	dp = dbp->dp;

	/* CfbNXt@CI[v`FbN */
	if (dbp->nIdx >= MAX_IDX) {
		DBErr(IE_IDXOVER);
		return(0);
	}

	/* CfbNXt@C쐬 */
	if ((ip = IDXCreate(fileName, key, uniq)) == NULL)
		return(0);

	IDXMake(dp, ip);	/* CfbNX\z */

	dbp->ip[dbp->nIdx+1] = ip;	/* CfbNX|C^Z[u */

	dbp->nIdx++;		/* CfbNXt@CXV */

	/* }X^[CfbNXt@CԍZbg */
	if (dbp->master == 0) {
		dbp->master = dbp->nIdx;
		DBTop(dbp);
	}

	return(dbp->nIdx);
}

/*=======================================================================
 |
 |		}X^[CfbNX؂ւ
 |
 |	VOID	DBChgIdx(dbp, n)
 |
 |		DB	*dbp;		ca|C^
 |		SHORT	n;		CfbNXt@Cԍ
 |
 =======================================================================*/
VOID	DBChgIdx(DB *dbp, SHORT n)
{
	dbp->master = n;	/* }X^[CfbNXԍZbg */
	DBTop(dbp);		/* 擪R[h */
}

/*=======================================================================
 |
 |		CfbNXt@Cɂ錟
 |
 |	VOID	DBSearch(dbp, key, len, index)
 |
 |		DB	*dbp;		ca|C^
 |		CHAR	*key;		镶
 |		SHORT	len;		镶̒
 |		SHORT	index;		CfbNXt@Cԍ
 |
 |		BOOL	Ԓl		TRUE F
 |					FALSEFȂ
 |
 =======================================================================*/
BOOL	DBSearch(DB *dbp, CHAR *key, SHORT len, SHORT index)
{
	DBF	*dp;
	IDX	*ip;
	LONG	rno;

	dbp->master = index;

	/* |C^Zbg */
	dp = dbp->dp;
	ip = dbp->ip[dbp->master];

	/* CfbNXt@CȂΉȂ */
	if (ip == NULL)
		return(FALSE);

	rno = IDXSearch(ip, key, len);		/*  */

	if (_dbSetDeleted && rno != 0L) {
		/* 폜R[hXLbv */
		while (DBFCheckDeleted(dp, rno)) {
			if ((rno = IDXNext(ip)) == 0)
				break;
			if (IDXCompare(ip, key, len) != 0) {
				rno = 0;
				break;
			}
		}
	}

	CheckEof(dbp, rno);	/* dne`FbN */

	return(!DBEof(dbp));
}

/*=======================================================================
 |
 |		L[Ɉv郌R[h߂
 |
 |	LONG	DBCount(dbp, key, len, index)
 |
 |		DB	*dbp;		ca|C^
 |		CHAR	*key;		镶
 |		SHORT	len;		镶̒
 |		SHORT	index;		CfbNXt@Cԍ
 |
 |		Ԓl			L[ɈvR[h
 |
 =======================================================================*/
LONG	DBCount(DB *dbp, CHAR *key, SHORT len, SHORT index)
{
	DBF	*dp;
	IDX	*ip;
	LONG	count, rno;

	dbp->master = index;

	/* |C^Zbg */
	dp = dbp->dp;
	ip = dbp->ip[dbp->master];

	/* CfbNXt@CȂΉȂ */
	if (ip == NULL)
		return(0L);

	count = 0;
	if ((rno = IDXSearch(ip, key, len)) != 0) {	/*  */
		for (;;) {
			if (_dbSetDeleted == FALSE
					|| DBFCheckDeleted(dp, rno) == 0)
				count++;
			if ((rno = IDXNext(ip)) == 0)
				break;
			if (IDXCompare(ip, key, len) != 0)
				break;
		}
	}

	CheckEof(dbp, rno);	/* dne`FbN */

	return(count);
}

/*=======================================================================
 |
 |		R[hǉ
 |
 |	VOID	DBStore(dbp, rec)
 |
 |		DB	*dbp;		ca|C^
 |		VOID	*rec;		ǉ郌R[hf[^ւ̃|C^
 |
 =======================================================================*/
VOID	DBStore(DB *dbp, VOID *rec)
{
	DBF	*dp;
	IDX	*ip;
	USHORT	i;
	DBF_H	*dhp;
	IDX_H	*ihp;
	CHAR	kbuf[100];

	/* |C^Zbg */
	dp = dbp->dp;
	dhp = dp->dhp;

	dp->rbp[0] = ' ';	/* 폜R[htONA */
	memcpy(dp->rbp+1, rec, dhp->lRec-1);	/* f[^Rs[ */

	/* f[^t@Cɒǉ */
	dbp->rno = ++dhp->nRec;
	DBFWrite(dp, dbp->rno);
	dp->wFlag = TRUE;

	/* CfbNXt@CXV */
	for (i = 1; i <= dbp->nIdx; i++) {
		ip = dbp->ip[i];
		ihp = ip->ihp;

		if (GetKey(dp, ihp, kbuf) != 0)
			IDXStore(ip, kbuf, dhp->nRec);
	}

	/* CfbNXt@C̃|C^Zbg */
	DBSet(dbp, dbp->rno);

	dbp->updateFlag = TRUE;
}

/*=======================================================================
 |
 |		R[hXV
 |
 |	VOID	DBUpdate(dbp, rec)
 |
 |		DB	*dbp;		ca|C^
 |		VOID	*rec;		XV郌R[hf[^ւ̃|C^
 |
 =======================================================================*/
VOID	DBUpdate(DB *dbp, VOID *rec)
{
	DBF	*dp;
	IDX	*ip;
	USHORT	i;
	DBF_H	*dhp;
	IDX_H	*ihp;
	LONG	rno;
	CHAR	kbuf1[100], kbuf2[100];

	/* ane܂͂dneȂG[ */
	if (dbp->bof || dbp->eof) {
		DBErr(IE_EOF);
		return;
	}

	/* |C^Zbg */
	dp = dbp->dp;
	dhp = dp->dhp;

	DBFRead(dp, dbp->rno);		/* R[hǂݍ */

	/* CfbNXt@CXV */
	for (i = 1; i <= dbp->nIdx; i++) {
		ip = dbp->ip[i];
		ihp = ip->ihp;

		if (GetKey(dp, ihp, kbuf1) != 0) {
			rno = IDXSearch(ip, kbuf1, ihp->lKey);
			while (rno != dbp->rno && rno != 0)
				rno = IDXNext(ip);
			if (rno != 0) {
				memcpy(dp->rbp+1, rec, dhp->lRec-1);
				GetKey(dp, ihp, kbuf2);
				if (memcmp(kbuf1, kbuf2, ihp->lKey) != 0) {
					IDXDelete(ip);
					IDXStore(ip, kbuf2, rno);
				}
				dp->rno = 0;
				DBFRead(dp, dbp->rno);	/* R[hǂݍ */
			}
		}
	}

	/* f[^t@CXV */
	memcpy(dp->rbp+1, rec, dhp->lRec-1);
	DBFWrite(dp, dbp->rno);

	/* CfbNXt@C̃|C^Zbg */
	DBSet(dbp, dbp->rno);

	dbp->updateFlag = TRUE;
}

/*=======================================================================
 |
 |		R[h폜
 |
 |	VOID	DBDelete(dbp)
 |
 |		DB	*dbp;		ca|C^
 |
 =======================================================================*/
VOID	DBDelete(DB *dbp)
{
	/* ane܂͂dneȂG[ */
	if (dbp->bof || dbp->eof) {
		DBErr(IE_EOF);
		return;
	}

	DBFDelete(dbp->dp, dbp->rno);	/* 폜}[NZbg */

	SkipDeleted(dbp, 1);		/* 폜R[hXLbv */
}

/*=======================================================================
 |
 |		R[h
 |
 |	VOID	DBRecall(dbp)
 |
 |		DB	*dbp;		ca|C^
 |
 =======================================================================*/
VOID	DBRecall(DB *dbp)
{
	/* ane܂͂dneȂG[ */
	if (dbp->bof || dbp->eof) {
		DBErr(IE_EOF);
		return;
	}

	DBFRecall(dbp->dp, dbp->rno);	/* 폜}[N */
}

/*=======================================================================
 |
 |		R[h̕I폜
 |
 |	VOID	DBDelete2(dbp)
 |
 |		DB	*dbp;		ca|C^
 |
 =======================================================================*/
VOID	DBDelete2(DB *dbp)
{
	DBF	*dp;
	DBF_H	*dhp;
	IDX	*ip;
	USHORT	i;
	CHAR	*rbufp;
	LONG	rno;
	CHAR	kbuf[100];

	/* ane܂͂dneȂG[ */
	if (dbp->bof || dbp->eof) {
		DBErr(IE_EOF);
		return;
	}

	dp = dbp->dp;
	dhp = dp->dhp;

	/* R[hۑGAm */
	if ((rbufp = malloc(dp->dhp->lRec - 1)) == 0) {
		DBErr(IE_MEMORY);
		return;
	}

	DBFRead(dp, dhp->nRec);	/* ŏIR[hǂݍ */

	/* IŏIR[hCfbNXt@C폜 */
	for (i = 1; i <= dbp->nIdx; i++) {
		ip = dbp->ip[i];

		if (GetKey(dp, ip->ihp, kbuf) != 0) {
			rno = IDXSearch(ip, kbuf, ip->ihp->lKey);
			while (rno != dhp->nRec && rno != 0)
				rno = IDXNext(ip);
			if (rno != 0)
				IDXDelete(ip);		/* L[̍폜 */
		}
	}

	/* ŏIR[hȊȌꍇA폜郌R[hɍŏIR[h㏑ */
	if (dbp->rno != dhp->nRec) {
		memcpy(rbufp, dp->rbp + 1, dhp->lRec - 1);
		DBUpdate(dbp, rbufp);
	}

	free(rbufp);

	dhp->nRec--;			/* R[h|P */
	dp->update = TRUE;		/* t@CXVtOZbg */

	/* t@CTCY𒲐 */
	chsize(dp->fh, dhp->lHeader + dhp->lRec * dhp->nRec);

	dbp->updateFlag = TRUE;
}

/*=======================================================================
 |
 |		R[h̕I폜i폜Jg|C^͎R[hj
 |
 |	VOID	DBDelete3(dbp)
 |
 |		DB	*dbp;		ca|C^
 |
 =======================================================================*/
VOID	DBDelete3(DB *dbp)
{
	IDX	*ip;
	LONG	nextRno;

	/* ane܂͂dneȂG[ */
	if (dbp->bof || dbp->eof) {
		DBErr(IE_EOF);
		return;
	}

	/* R[hԍۑ */
	ip = dbp->ip[dbp->master];
	if (ip != NULL)
		nextRno = IDXNext(ip);

	/* R[h̕I폜 */
	DBDelete2(dbp);

	/* R[hɃR[h|C^Zbg */
	if (ip != NULL) {
		if (nextRno != 0) {
			if (nextRno <= dbp->dp->dhp->nRec)
				DBSet(dbp, nextRno);
		} else
			CheckEof(dbp, 0L);
	}
}

/*=======================================================================
 |
 |		R[h̕I폜i폜Jg|C^͑OR[hj
 |
 |	VOID	DBDelete4(dbp)
 |
 |		DB	*dbp;		ca|C^
 |
 =======================================================================*/
VOID	DBDelete4(DB *dbp)
{
	IDX	*ip;
	LONG	backRno;

	/* ane܂͂dneȂG[ */
	if (dbp->bof || dbp->eof) {
		DBErr(IE_EOF);
		return;
	}

	/* OR[hԍۑ */
	ip = dbp->ip[dbp->master];
	if (ip != NULL)
		backRno = IDXBack(ip);

	/* R[h̕I폜 */
	DBDelete2(dbp);

	/* OR[hɃR[h|C^Zbg */
	if (ip != NULL) {
		if (backRno != 0) {
			if (backRno <= dbp->dp->dhp->nRec)
				DBSet(dbp, backRno);
		} else
			CheckBof(dbp, 0L);
	}
}

/*=======================================================================
 |
 |		R[h|C^擪R[hɃZbg
 |
 |	VOID	DBTop(dbp)
 |
 |		DB	*dbp;		ca|C^
 |
 =======================================================================*/
VOID	DBTop(DB *dbp)
{
	IDX	*ip;

	ip = dbp->ip[dbp->master];

	CheckBof(dbp, (ip == NULL) ? 1L : IDXTop(ip));

	SkipDeleted(dbp, 1);	/* 폜R[hXLbv */
}

/*=======================================================================
 |
 |		R[h|C^ŏIR[hɃZbg
 |
 |	VOID	DBBottom(dbp)
 |
 |		DB	*dbp;		ca|C^
 |
 =======================================================================*/
VOID	DBBottom(DB *dbp)
{
	IDX	*ip;

	ip = dbp->ip[dbp->master];

	CheckEof(dbp, (ip == NULL) ? dbp->dp->dhp->nRec : IDXBottom(ip));

	SkipDeleted(dbp, -1);	/* 폜R[hXLbv */
}

/*=======================================================================
 |
 |		R[h|C^w肳ꂽR[hɃZbg
 |
 |	VOID	DBSet(dbp, recno)
 |
 |		DB	*dbp;		ca|C^
 |		LONG	recno;		R[hԍ
 |
 =======================================================================*/
VOID	DBSet(DB *dbp, LONG recno)
{
	DBF	*dp;
	IDX	*ip;
	LONG	rno;
	CHAR	kbuf[100];
	
	/* |C^Zbg */
	dp = dbp->dp;
	ip = dbp->ip[dbp->master];

	if (ip != NULL) {
		/* CfbNXt@Cꍇ */
		DBFRead(dp, recno);	/* R[hǂݍ */

		/* CfbNXt@C̎w肳ꂽR[hԍT */
		if (GetKey(dp, ip->ihp, kbuf) != 0) {
			rno = IDXSearch(ip, kbuf, ip->ihp->lKey);
			while (rno != recno && rno != 0)
				rno = IDXNext(ip);
		}
	}

	CheckEof(dbp, recno);	/* dne`FbN */
}

/*=======================================================================
 |
 |		R[h|C^̑Oړ
 |
 |	VOID	DBSkip(dbp, n)
 |
 |		DB	*dbp;		ca|C^
 |		LONG	n;		ړR[h
 |
 =======================================================================*/
VOID	DBSkip(DB *dbp, LONG n)
{
	if (n != 0) {
		Skip(dbp, n);	/* R[h|C^ړ */
		SkipDeleted(dbp, n > 0 ? 1 : -1); /* 폜R[hXLbv */
	}
}

/*=======================================================================
 |
 |		CfbNXt@Cč\z
 |
 |	VOID	DBReindex(dbp)
 |
 |		DB	*dbp;		ca|C^
 |
 =======================================================================*/
VOID	DBReindex(DB *dbp)
{
	DBF	*dp;
	USHORT	i;

	dp = dbp->dp;

	for (i = 1; i <= dbp->nIdx; i++) {
		IDXMake(dp, dbp->ip[i]);	/* CfbNX\z */
	}

	DBTop(dbp);

	dbp->updateFlag = TRUE;
}

/*=======================================================================
 |
 |		폜R[ht@Cォ폜
 |
 |	VOID	DBPack(dbp)
 |
 |		DB	*dbp;		ca|C^
 |
 =======================================================================*/
VOID	DBPack(DB *dbp)
{
	DBFPack(dbp->dp);	/* 폜R[h̍폜 */
	DBReindex(dbp);	/* CfbNXt@Cč\z */
}

/*=======================================================================
 |
 |		JgR[hǂݍ
 |
 |	VOID	DBRead(dbp, p)
 |
 |		DB	*dbp;		ca|C^
 |		VOID	*p;		R[hǂݍ݃obt@|C^
 |
 =======================================================================*/
VOID	DBRead(DB *dbp, VOID *p)
{
	DBF	*dp;

	/* ane܂͂dneȂG[ */
	if (dbp->bof || dbp->eof) {
		DBErr(IE_EOF);
		return;
	}

	dp = dbp->dp;
	DBFRead(dp, dbp->rno);		/* ǂݍ */
	memcpy(p, dp->rbp + 1, dp->dhp->lRec - 1);	/* obt@ɃRs[ */
}

/*=======================================================================
 |
 |		f[^x[Xt@CbN
 |
 |	VOID	DBLock(dbp)
 |
 |		DB	*dbp;		ca|C^
 |
 =======================================================================*/
VOID	DBLock(DB *dbp)
{
	DosFSRamSemRequest(&dbp->sem, SEM_INDEFINITE_WAIT);
}

/*=======================================================================
 |
 |		f[^x[Xt@CbN
 |
 |	VOID	DBRelease(dbp)
 |
 |		DB	*dbp;		ca|C^
 |
 =======================================================================*/
VOID	DBRelease(DB *dbp)
{
	DosFSRamSemClear(&dbp->sem);
}

/*=======================================================================
 |
 |		JgR[h|C^̘_R[hԍo
 |
 |	LONG	DBGetRecNo(dbp)
 |
 |		DB	*dbp;		ca|C^
 |
 |		LONG	Ԓl		R[hԍ
 |
 =======================================================================*/
LONG	DBGetRecNo(DB *dbp)
{
	LONG	pRecNo, recNo;

	pRecNo = DBRecNo(dbp);
	DBTop(dbp);
	for (recNo = 0; pRecNo != DBRecNo(dbp); recNo++)
		DBSkip(dbp, 1L);
	return(recNo);
}

/*=======================================================================
 |
 |		f[^t@CTCY`FbN
 |
 |	BOOL	DBCheckSize(dbp)
 |
 |		DB	*dbp;		ca|C^
 |
 |		BOOL	Ԓl		TRUE Ft@CTCY𒲐
 |					FALSEFt@CTCY͐
 |
 =======================================================================*/
BOOL	DBCheckSize(DB *dbp)
{
	DBF	*dp;
	DBF_H	*dhp;
	LONG	nRec;

	dp = dbp->dp;
	dhp = dp->dhp;

	lseek(dp->fh, 0L, SEEK_END);
	nRec = (tell(dp->fh) - dhp->lHeader) / dhp->lRec;
	if (nRec < 0)
		nRec = 0;
	if (nRec != dhp->nRec) {
		dhp->nRec = nRec;
		dp->update = TRUE;	/* t@CXVtOZbg */
		return(TRUE);
	}
	return(FALSE);
}

/*=======================================================================
 |
 |		XVtO`FbN
 |
 |	BOOL	DBCheckUpdate(dbp)
 |
 |		DBX	*dbp;		ca|C^
 |
 |		BOOL	Ԓl		TRUE FXVꂽ
 |					FALSEFXVĂȂ
 |
 =======================================================================*/
BOOL	DBCheckUpdate(DB *dbp)
{
	return(dbp->updateFlag);
}

/*=======================================================================
 |
 |		XVtOZbg
 |
 |	VOID	DBResetUpdate(dbp)
 |
 |		DBX	*dbp;		ca|C^
 |
 =======================================================================*/
VOID	DBResetUpdate(DB *dbp)
{
	dbp->updateFlag = FALSE;
}

/*=======================================================================
 |
 |		폜R[h̃XLbv
 |
 |	VOID	SkipDeleted(dbp, n)
 |
 |		DB	*dbp;		ca|C^
 |		SHORT	n;		PFփXLbv@|PFOփXLbv
 |
 =======================================================================*/
static	VOID	SkipDeleted(DB *dbp, SHORT n)
{
	DBF	*dp;

	if (_dbSetDeleted != FALSE && n != 0) {
		dp = dbp->dp;
		while (!(dbp->bof || dbp->eof) && DBFCheckDeleted(dp, dbp->rno)) {
			Skip(dbp, (LONG)n);
		}
	}
}

/*=======================================================================
 |
 |		R[h̑Oړ
 |
 |	VOID	Skip(dbp, n)
 |
 |		DB	*dbp;		ca|C^
 |		LONG	n;		ړR[h
 |
 =======================================================================*/
static	VOID	Skip(DB *dbp, LONG n)
{
	DBF	*dp;
	IDX	*ip;
	LONG	rno;

	dp = dbp->dp;
	ip = dbp->ip[dbp->master];

	if (ip == NULL) {
		/* CfbNXt@CȂꍇ */
		rno = dbp->rno + n;
		if (rno <= 0)
			CheckBof(dbp, 0L);
		else if (rno > dp->dhp->nRec)
			CheckEof(dbp, 0L);
		else
			CheckEof(dbp, rno);
	} else {
		/* CfbNXt@Cꍇ */
		if (n > 0) {
			if (dbp->bof)
				rno = IDXTop(ip);
			while (n-- != 0) {
				rno = IDXNext(ip);
				if (rno == 0)
					break;
			}
			CheckEof(dbp, rno);
		} else if (n < 0) {
			if (dbp->eof) {
				rno = IDXBottom(ip);
				n++;
			}
			while (n++ != 0) {
				rno = IDXBack(ip);
				if (rno == 0)
					break;
			}
			CheckBof(dbp, rno);
		}
	}
}

/*=======================================================================
 |
 |		ane`FbN
 |
 |	VOID	CheckBof(dbp, rno)
 |
 |		DB	*dbp;		ca|C^
 |		LONG	rno;		R[hԍ
 |
 =======================================================================*/
static	VOID	CheckBof(DB *dbp, LONG rno)
{
	if (dbp->dp->dhp->nRec == 0) {
		/* R[hPȂꍇ */
		dbp->rno = 1;
		dbp->bof = TRUE;
		dbp->eof = TRUE;
	} else {
		if (rno == 0) {
			dbp->rno = 1;
			dbp->bof = TRUE;
			dbp->eof = FALSE;
		} else {
			dbp->rno = rno;
			dbp->bof = FALSE;
			dbp->eof = FALSE;
		}
	}
}

/*=======================================================================
 |
 |		dne`FbN
 |
 |	VOID	CheckEof(dbp, rno)
 |
 |		DB	*dbp;		ca|C^
 |		LONG	rno;		R[hԍ
 |
 =======================================================================*/
static	VOID	CheckEof(DB *dbp, LONG rno)
{
	if (dbp->dp->dhp->nRec == 0) {
		/* R[hPȂꍇ */
		dbp->rno = 1;
		dbp->bof = TRUE;
		dbp->eof = TRUE;
	} else {
		if (rno == 0) {
			dbp->rno = dbp->dp->dhp->nRec + 1;
			dbp->bof = FALSE;
			dbp->eof = TRUE;
		} else {
			dbp->rno = rno;
			dbp->bof = FALSE;
			dbp->eof = FALSE;
		}
	}
}


/*=======================================================================
 |
 |		f[^t@CI[v
 |
 |	DBF	*DBFOpen(fileName)
 |
 |		CHAR	*fileName;	f[^t@C
 |
 |		Ԓl			cae|C^
 |
 =======================================================================*/
DBF	*DBFOpen(CHAR *fileName)
{
	DBF	*dp;
	FIELD	*flp;
	CHAR	*rbp;
	USHORT	i;

	/* f[^t@CǗGAm */
	if ((dp = malloc(sizeof(DBF))) == 0) {
		DBErr(IE_MEMORY);
		return(NULL);
	}
	memset(dp, 0, sizeof(DBF));

	/* f[^t@CI[v */
	if ((dp->fh = open(fileName, O_BINARY|O_RDWR)) == -1) {
		DBFClose(dp);
		DBErr(IE_NOFILE);
		return(NULL);
	}

	strcpy(dp->fileName, fileName);	/* t@CZ[u */

	/* wb_GAm */
	if ((dp->dhp = malloc(sizeof(DBF_H))) == 0) {
		DBFClose(dp);
		DBErr(IE_MEMORY);
		return(NULL);
	}

	/* wb_ǂݍ */
	if (read(dp->fh, dp->dhp, sizeof(DBF_H)) != sizeof(DBF_H)) {
		DBFClose(dp);
		DBErr(IE_READ);
		return(NULL);
	}

	/* tB[hGAm */
	dp->nField = (dp->dhp->lHeader - 33) / 32;
	if ((dp->flp = malloc(sizeof(FIELD) * dp->nField)) == 0) {
		DBFClose(dp);
		DBErr(IE_MEMORY);
		return(NULL);
	}

	/* tB[hǂݍ */
	if (read(dp->fh, dp->flp, sizeof(FIELD) * dp->nField) !=
					(int)(sizeof(FIELD) * dp->nField)) {
		DBFClose(dp);
		DBErr(IE_READ);
		return(NULL);
	}

	/* R[hobt@m */
	if ((dp->rbp = malloc(dp->dhp->lRec)) == 0) {
		DBFClose(dp);
		DBErr(IE_MEMORY);
		return(NULL);
	}

	/* tB[h|C^Zbg */
	flp = dp->flp;
	rbp = dp->rbp + 1;
	for (i = 0; i < dp->nField; i++) {
		flp->fad = rbp;
		rbp += flp->lField;
		flp++;
	}

	return(dp);
}

/*=======================================================================
 |
 |		f[^t@C쐬
 |
 |	DBF	*DBFCreate(fileName, dip, nField)
 |
 |		CHAR	*fileName;	f[^t@C
 |		DBF_I	*dip;		f[^t@C
 |		SHORT	nField;		tB[h
 |
 |		Ԓl			cae|C^
 |
 =======================================================================*/
DBF	*DBFCreate(CHAR *fileName, DBF_I *dip, SHORT nField)
{
	DBF	*dp;
	DBF_H	*dhp;
	FIELD	*flp;
	CHAR	*rbp;
	SHORT	i;
	static	CHAR	cr_eof[2] = {0x0d, 0x1a};

	/* f[^t@CǗGAm */
	if ((dp = malloc(sizeof(DBF))) == 0) {
		DBErr(IE_MEMORY);
		return(NULL);
	}
	memset(dp, 0, sizeof(DBF));

	/* f[^t@CI[v */
	if ((dp->fh = open(fileName, O_BINARY|O_RDWR|O_CREAT,
						S_IREAD|S_IWRITE)) == -1) {
		DBFClose(dp);
		DBErr(IE_FOPEN);
		return(NULL);
	}

	strcpy(dp->fileName, fileName);	/* t@CZ[u */

	/* wb_GAm */
	if ((dhp = malloc(sizeof(DBF_H))) == 0) {
		DBFClose(dp);
		DBErr(IE_MEMORY);
		return(NULL);
	}
	memset(dhp, 0, sizeof(DBF_H));
	dp->dhp = dhp;

	/* wb_ݒ */
	dhp->flag = 0x03;
	dhp->lHeader = (nField + 1) * 32 + 1;

	/* wb_񏑂 */
	if (write(dp->fh, dp->dhp, sizeof(DBF_H)) != sizeof(DBF_H)) {
		DBFClose(dp);
		DBErr(IE_WRITE);
		return(NULL);
	}

	/* tB[hGAm */
	dp->nField = nField;
	if ((dp->flp = malloc(sizeof(FIELD) * nField)) == 0) {
		DBFClose(dp);
		DBErr(IE_MEMORY);
		return(NULL);
	}
	memset(dp->flp, 0, sizeof(FIELD) * nField);

	/* tB[hݒ */
	for (i = 0, flp = dp->flp, dhp->lRec = 1; i < nField; i++, flp++) {
		memcpy(flp->name, dip->name, 11);
		flp->type = dip->type;
		flp->lField = dip->lField;
		flp->lDec = dip->lDec;
		dhp->lRec += dip->lField;
		dip++;
	}

	/* tB[h񏑂 */
	if (write(dp->fh, dp->flp, sizeof(FIELD) * dp->nField) !=
					(int)(sizeof(FIELD) * dp->nField)) {
		DBFClose(dp);
		DBErr(IE_WRITE);
		return(NULL);
	}

	/* ؂蕶dne */
	if (write(dp->fh, cr_eof, 2) != 2) {
		DBFClose(dp);
		DBErr(IE_WRITE);
		return(NULL);
	}

	/* R[hobt@m */
	if ((dp->rbp = malloc(dhp->lRec)) == 0) {
		DBFClose(dp);
		DBErr(IE_MEMORY);
		return(NULL);
	}

	/* tB[h|C^Zbg */
	flp = dp->flp;
	rbp = dp->rbp + 1;
	for (i = 0; i < nField; i++) {
		flp->fad = rbp;
		rbp += flp->lField;
		flp++;
	}

	dp->update = TRUE;

	return(dp);
}

/*=======================================================================
 |
 |		R[hǂݍ
 |
 |	VOID	DBFRead(dp, rno)
 |
 |		DBF	*dp;		cae|C^
 |		LONG	rno;		R[hԍ
 |
 =======================================================================*/
VOID	DBFRead(DBF *dp, LONG rno)
{
	DBF_H	*dhp;

	dhp = dp->dhp;

	/* R[hԍ͈͊OȂG[ */
	if (rno <= 0 || rno > dhp->nRec) {
		DBErr(IE_RECNO);
		return;
	}

	if (rno != dp->rno) {
		/* ǂݍ */
		lseek(dp->fh, dhp->lHeader + dhp->lRec*(rno-1), SEEK_SET);
		if (read(dp->fh, dp->rbp, dhp->lRec) != (int)dhp->lRec)
			DBErr(IE_READ);

		dp->rno = rno;	/* JgR[hԍZbg */
	}
}

/*=======================================================================
 |
 |		R[h
 |
 |	VOID	DBFWrite(dp, rno)
 |
 |		DBF	*dp;		cae|C^
 |		LONG	rno;		R[hԍ
 |
 =======================================================================*/
VOID	DBFWrite(DBF *dp, LONG rno)
{
	DBF_H	*dhp;

	dhp = dp->dhp;

	/* R[hԍ͈͊OȂG[ */
	if (rno <= 0 || rno > dhp->nRec) {
		DBErr(IE_RECNO);
		return;
	}

	/*  */
	lseek(dp->fh, dhp->lHeader + dhp->lRec*(rno-1), SEEK_SET);
	if (write(dp->fh, dp->rbp, dhp->lRec) != (int)dhp->lRec)
		DBErr(IE_WRITE);

	dp->rno = rno;		/* JgR[hԍZbg */
	dp->update = TRUE;		/* t@CXVtOZbg */
}

/*=======================================================================
 |
 |		f[^t@CN[Y
 |
 |	VOID	DBFClose(dp)
 |
 |		DBF	*dp;		cae|C^
 |
 =======================================================================*/
VOID	DBFClose(DBF *dp)
{
	DBF_H	*dhp;
	LONG	ltime;
	struct	tm	*tmp;

	if (dp->fh != -1) {
		if (dp->update) {
			/* ŏIXV */
			dhp = dp->dhp;
			time(&ltime);
			tmp = localtime(&ltime);
			dhp->date[0] = (CHAR)tmp->tm_year;
			dhp->date[1] = (CHAR)(tmp->tm_mon + 1);
			dhp->date[2] = (CHAR)tmp->tm_mday;
			dp->wFlag = TRUE;
		}

		DBFFlush(dp);		/* t@C */
		close(dp->fh);		/* t@CN[Y */
	}

	if (dp->dhp != NULL)
		free(dp->dhp);		/* wb_GA */

	if (dp->flp != NULL)
		free(dp->flp);		/* tB[hGA */

	if (dp->rbp != NULL)
		free(dp->rbp);		/* R[hobt@GA */

	free(dp);		/* f[^t@CǗGA */
}

/*=======================================================================
 |
 |		f[^t@C|o
 |
 |	VOID	DBFFlush(dp)
 |
 |		DBF	*dp;		cae|C^
 |
 =======================================================================*/
VOID	DBFFlush(DBF *dp)
{
	static	CHAR	eof[1] = {0x1a};
	DBF_H	*dhp;

	if (dp->wFlag) {
		dhp = dp->dhp;

		/* wb_ */
		lseek(dp->fh, 0L, SEEK_SET);
		if (write(dp->fh, dp->dhp, sizeof(DBF_H)) != sizeof(DBF_H))
			DBErr(IE_WRITE);

		/* dne */
		lseek(dp->fh, dhp->lHeader + dhp->lRec * dhp->nRec, SEEK_SET);
		if (write(dp->fh, eof, 1) != 1)
			DBErr(IE_WRITE);

		dp->wFlag = FALSE;
	}

	close(dp->fh);
	dp->fh = open(dp->fileName, O_BINARY|O_RDWR);
}

/*=======================================================================
 |
 |		폜}[NZbg
 |
 |	VOID	DBFDelete(dp, rno)
 |
 |		DBF	*dp;		cae|C^
 |		LONG	rno;		R[hԍ
 |
 =======================================================================*/
VOID	DBFDelete(DBF *dp, LONG rno)
{
	DBFRead(dp, rno);	/* R[hǂݍ */
	*dp->rbp = '*';		/* 폜}[NZbg */
	DBFWrite(dp, rno);	/* R[h */
}

/*=======================================================================
 |
 |		폜}[N
 |
 |	VOID	DBFRecall(dp, rno)
 |
 |		DBF	*dp;		cae|C^
 |		LONG	rno;		R[hԍ
 |
 =======================================================================*/
VOID	DBFRecall(DBF *dp, LONG rno)
{
	DBFRead(dp, rno);	/* R[hǂݍ */
	*dp->rbp = ' ';		/* 폜}[N */
	DBFWrite(dp, rno);	/* R[h */
}

/*=======================================================================
 |
 |		폜}[NĂ郌R[ht@C폜
 |
 |	VOID	DBFPack(dp)
 |
 |		DBF	*dp;		cae|C^
 |
 =======================================================================*/
VOID	DBFPack(DBF *dp)
{
	DBF_H	*dhp;
	LONG	rRno, wRno;

	dhp = dp->dhp;

	/* 폜}[NtĂ郌R[h폜 */
	for (rRno = wRno = 0; rRno < dhp->nRec; ) {
		DBFRead(dp, ++rRno);
		if (dp->rbp[0] != '*') {
			if (rRno != ++wRno) {
				DBFWrite(dp, wRno);
			}
		}
	}

	/* t@CTCY𒲐 */
	chsize(dp->fh, dhp->lHeader + dhp->lRec * wRno);

	/* R[hZbg */
	dhp->nRec = wRno;
	dp->wFlag = TRUE;

	dp->rno = 0;
}

/*=======================================================================
 |
 |		폜R[h`FbN
 |
 |	SHORT	DBFCheckDeleted(dp, rno)
 |
 |		DBF	*dp;		cae|C^
 |		long	rno;		R[hԍ
 |
 |		Ԓl			OFʏ탌R[h@PF폜R[h
 |
 =======================================================================*/
SHORT	DBFCheckDeleted(DBF *dp, long rno)
{
	DBFRead(dp, rno);
	return(*dp->rbp == '*' ? 1 : 0);
}

/*=======================================================================
 |
 |		CfbNXt@CI[v
 |
 |	IDX	*IDXOpen(fileName)
 |
 |		CHAR	*fileName;	CfbNXt@C
 |
 |		Ԓl			hcw|C^
 |
 =======================================================================*/
IDX	*IDXOpen(CHAR *fileName)
{
	IDX	*ip;

	/* CfbNXǗGAm */
	if ((ip = malloc(sizeof(IDX))) == 0) {
		DBErr(IE_MEMORY);
		return(NULL);
	}
	memset(ip, 0, sizeof(IDX));

	/* CfbNXt@CI[v */
	if ((ip->fh = open(fileName, O_BINARY|O_RDWR)) == -1) {
		IDXClose(ip);
		DBErr(IE_NOFILE);
		return(NULL);
	}

	strcpy(ip->fileName, fileName);	/* t@CZ[u */

	/* wb_GAm */
	if ((ip->ihp = malloc(sizeof(IDX_H))) == 0) {
		IDXClose(ip);
		DBErr(IE_MEMORY);
		return(NULL);
	}

	/* wb_ǂݍ */
	if (read(ip->fh, ip->ihp, sizeof(IDX_H)) != sizeof(IDX_H)) {
		IDXClose(ip);
		DBErr(IE_READ);
		return(NULL);
	}

	return(ip);
}

/*=======================================================================
 |
 |		CfbNXt@C쐬
 |
 |	IDX	*IDXCreate(fileName, key, uniq)
 |
 |		CHAR	*fileName;	CfbNXt@C
 |		CHAR	*key;		L[
 |		SHORT	uniq;		OFL[̏d@PFȂ
 |
 |		Ԓl			hcw|C^
 |
 =======================================================================*/
IDX	*IDXCreate(CHAR *fileName, CHAR *key, SHORT uniq)
{
	IDX	*ip;
	IDX_H	*ihp;

	/* CfbNXǗGAm */
	if ((ip = malloc(sizeof(IDX))) == 0) {
		DBErr(IE_MEMORY);
		return(NULL);
	}
	memset(ip, 0, sizeof(IDX));

	/* CfbNXt@CI[v */
	if ((ip->fh = open(fileName, O_BINARY|O_RDWR|O_CREAT,
						S_IREAD|S_IWRITE)) == -1) {
		IDXClose(ip);
		DBErr(IE_NOFILE);
		return(NULL);
	}

	strcpy(ip->fileName, fileName);	/* t@CZ[u */

	/* wb_GAm */
	if ((ihp = malloc(sizeof(IDX_H))) == 0) {
		IDXClose(ip);
		DBErr(IE_MEMORY);
		return(NULL);
	}
	ip->ihp = ihp;

	/* wb_ݒ */
	memset(ihp, 0, sizeof(IDX_H));
	sprintf(ihp->index, "%s ", key);
	ihp->uniq = (CHAR)(uniq ? 1 : 0);

	return(ip);
}

/*=======================================================================
 |
 |		CfbNXt@Cݒ
 |
 |	VOID	IDXSetInfo(ip, type, len)
 |
 |		IDX	*ip;		hcw|C^
 |		SHORT	type;		OF^@PFl^
 |		SHORT	len;		L[̒
 |
 =======================================================================*/
VOID	IDXSetInfo(IDX *ip, SHORT type, SHORT len)
{
	IDX_H	*ihp;

	ihp = ip->ihp;

	ihp->type = type;		/* f[^^Cvݒ */
	ihp->lKey = len;		/* L[ݒ */
	ihp->lRec = ((ihp->lKey - 1) & ~3) + 12;	/* R[hݒ */
	ihp->order = (BLOCK_SIZE - 4) / ihp->lRec;	/* ݒ */
}

/*=======================================================================
 |
 |		CfbNXt@Cǂݍ
 |
 |	IDX_B	*IDXRead(ip, bno)
 |
 |		IDX	*ip;		hcw|C^
 |		LONG	bno;		ubNԍ
 |
 |		Ԓl			ubNւ̃|C^
 |
 =======================================================================*/
IDX_B	*IDXRead(IDX *ip, LONG bno)
{
	IDX_B	**bpp, *bp;

	/* ubNobt@|C^`FbN */
	if (ip->bp == NULL)
		bpp = &ip->top;
	else
		bpp = &ip->bp->fwp;

	if (*bpp == NULL) {
		/* ubNGAm */
		if ((bp = malloc(sizeof(IDX_B))) == 0) {
			DBErr(IE_MEMORY);
			return(NULL);
		}
		memset(bp, 0, sizeof(IDX_B));

		/* `FC */
		*bpp = bp;
		bp->bwp = ip->bottom;
		ip->bottom = bp;
	} else
		bp = *bpp;

	if (bp->bno != bno) {
		if (bno != 0) {
			/* t@Cǂݍ */
			bp->bno = bno;
			lseek(ip->fh, bno * BLOCK_SIZE, SEEK_SET);
			if (read(ip->fh, bp->block, BLOCK_SIZE) != BLOCK_SIZE)
				DBErr(IE_READ);
		}
	}

	ip->bp = bp;

	return(bp);
}

/*=======================================================================
 |
 |		ubNGAm
 |
 |	IDX_B	*IDXGetBlk(ip, bno)
 |
 |		IDX	*ip;		hcw|C^
 |		LONG	bno;		ubNԍ
 |
 |		Ԓl			ubNւ̃|C^
 |
 =======================================================================*/
IDX_B	*IDXGetBlk(IDX *ip, LONG bno)
{
	IDX_B	*bp;

	bp = IDXRead(ip, 0L);	/* GAm */
	bp->bno = bno;		/* ubNԍZbg */

	return(bp);
}

/*=======================================================================
 |
 |		CfbNXt@C
 |
 |	VOID	IDXWrite(ip, bp)
 |
 |		IDX	*ip;		hcw|C^
 |		IDX_B	*bp;		ubN|C^
 |
 =======================================================================*/
VOID	IDXWrite(IDX *ip, IDX_B *bp)
{
	lseek(ip->fh, bp->bno * BLOCK_SIZE, SEEK_SET);
	if (write(ip->fh, bp->block, BLOCK_SIZE) != BLOCK_SIZE)
		DBErr(IE_WRITE);
}

/*=======================================================================
 |
 |		CfbNXt@CN[Y
 |
 |	VOID	IDXClose(ip)
 |
 |		IDX	*ip;		hcw|C^
 |
 =======================================================================*/
VOID	IDXClose(IDX *ip)
{
	IDX_B	*bp, *fwp;

	if (ip->fh != -1) {
		IDXFlush(ip);		/* t@C */
		close(ip->fh);		/* t@CN[Y */
	}

	/* ubNGA */
	for (bp = ip->top; bp != NULL; bp = fwp) {
		fwp = bp->fwp;
		free(bp);
	}

	if (ip->ihp != NULL)
		free(ip->ihp);		/* wb_GA */

	free(ip);		/* CfbNXǗGA */
}

/*=======================================================================
 |
 |		CfbNXt@C|o
 |
 |	VOID	IDXFlush(ip)
 |
 |		IDX	*ip;		hcw|C^
 |
 =======================================================================*/
VOID	IDXFlush(IDX *ip)
{
	if (ip->wFlag) {
		/* wb_񏑂 */
		lseek(ip->fh, 0L, SEEK_SET);
		if (write(ip->fh, ip->ihp, BLOCK_SIZE) != BLOCK_SIZE)
			DBErr(IE_WRITE);
		ip->wFlag = FALSE;
	}

	close(ip->fh);
	ip->fh = open(ip->fileName, O_BINARY|O_RDWR);
}

/*=======================================================================
 |
 |		
 |
 |	LONG	IDXSearch(ip, key, len)
 |
 |		IDX	*ip;		hcw|C^
 |		CHAR	*key;		镶
 |		SHORT	len;		镶̒
 |
 |		Ԓl			R[hԍ
 |
 =======================================================================*/
LONG	IDXSearch(IDX *ip, VOID *key, SHORT len)
{
	IDX_B	*bp;
	CHAR	*bufp;
	SHORT	m;
	SHORT	f;
	IDX_H	*ihp;
	LONG	bno;
	LONG	rno;

	ip->bp = NULL;		/* ubN|C^ */

	ihp = ip->ihp;		/* CfbNXwb_|C^Zbg */
	bno = ihp->root;	/* [gubNmDZbg */
	for (;;) {
		bp = IDXRead(ip, bno);	/* ubNf[^ǂݍ */

		bufp = bp->block;
		m = *(SHORT *)bufp;	/* ubNf[^o */
		bufp += 4;
		for (bp->cp = 0; bp->cp < m; bp->cp++) {
			ip->keyp = bufp + 8;
			f = IDXCompare(ip, key, len);	/* L[̔r */
			if (f == 0) {
				/* vꍇ */
				rno = *(LONG *)(bufp+4);
				if (rno != 0)
					return(rno);
				else
					break;
			} else if (f < 0)
				break;
			bufp += ihp->lRec;
		}

		if ((bno = *(LONG *)bufp) == 0)
			break;
	}

	return(0L);	/* vL[݂Ȃ */
}

/*=======================================================================
 |
 |		L[̔r
 |
 |	SHORT	IDXCompare(ip, key, len)
 |
 |		IDX	*ip;		hcw|C^
 |		CHAR	*key;		r镶
 |		SHORT	len;		r镶̒
 |
 |		Ԓl			r
 |
 =======================================================================*/
SHORT	IDXCompare(IDX *ip, VOID *key, SHORT len)
{
	return(memcmp(key, ip->keyp, len));
}

/*=======================================================================
 |
 |		L[̑}
 |
 |	VOID	IDXStore(ip, key, rno)
 |
 |		IDX	*ip;		hcw|C^
 |		CHAR	*key;		}L[
 |		LONG	rno;		R[hԍ
 |
 =======================================================================*/
VOID	IDXStore(IDX *ip, CHAR *key, LONG rno)
{
	IDX_B	*bp;
	IDX_H	*ihp;
	LONG	bno;
	SHORT	m, m1, m2;
	CHAR	*bufp;
	CHAR	keyBuf[100];

	ihp = ip->ihp;

	/* }ʒu */
	if (IDXCount(ip, key, ihp->lKey) != 0) {
		if (ihp->uniq) {
			DBErr(IE_DBLKEY);
			return;
		}
	}

	bno = 0;
	bp = ip->bp;
	for (;;) {
		if (bp == NULL) {
			/* [gubNč\z */
			bp = IDXGetBlk(ip, ihp->nBlock++);
			*(SHORT *)bp->block = 0;
			*(LONG *)(bp->block + 4) = ihp->root;
			ihp->root = bp->bno;
			bp->cp = 0;
		}
		bufp = bp->block;
		m = *(SHORT *)bufp;	/* ubNf[^o */
		bufp += 8 + bp->cp * ihp->lRec;

		/* ubNɑ} */
		memcpyr(bufp + ihp->lRec, bufp, ihp->lRec * (m - bp->cp));
		*(LONG *)bufp = rno;
		memcpy(bufp + 4, key, ihp->lKey);
		*((LONG *)(bufp + ihp->lRec - 4)) = bno;

		if (++m > (SHORT)ihp->order) {
			/* ubN̕ */
			m1 = (m + 1) / 2;
			m2 = m - m1;
			bufp = bp->block + 4 + m1 * ihp->lRec;
			if (rno == 0)
				m1--;
			*(SHORT *)bp->block = m1;
			key = keyBuf;
			memcpy(key, bufp - ihp->lRec + 8, ihp->lKey);
			IDXWrite(ip, bp);

			bno = bp->bno = ihp->nBlock++;
			ip->wFlag = TRUE;
			*(SHORT *)bp->block = m2;
			memcpy(bp->block + 4, bufp, m2 * ihp->lRec + 4);
			rno = 0;
			IDXWrite(ip, bp);

			bp = bp->bwp;
		} else {
			*(SHORT *)bp->block = m;
			IDXWrite(ip, bp);
			break;
		}
	}
}

/*	ʃAhX̃Rs[ */
static	VOID	memcpyr(CHAR *dst, CHAR *src, SHORT size)
{
	dst += size;
	src += size;
	while (size--)
		*(--dst) = *(--src);
}

/*=======================================================================
 |
 |		L[̍폜
 |
 |	VOID	IDXDelete(ip)
 |
 |		IDX	*ip;		hcw|C^
 |
 =======================================================================*/
VOID	IDXDelete(IDX *ip)
{
	IDX_H	*ihp;
	IDX_B	*bp;
	CHAR	*bufp, *key;
	SHORT	m;
	BOOL	loopSw;

	ihp = ip->ihp;
	key = NULL;
	bp = ip->bp;
	loopSw = TRUE;
	while (loopSw) {
		if (bp == NULL)
			break;

		bufp = bp->block;
		m = *(SHORT *)bufp;	/* ubNf[^o */
		bufp += 4 + bp->cp * ihp->lRec;
		if (key == NULL) {
			if (m == 0) {
				*(SHORT *)bufp = 0;
			} else {
				if (*(SHORT *)bufp == 0 && bp->cp == m-1) {
					if (m > 1)
						key = bufp - ihp->lRec + 8;
				} else if (bp->cp == m) {
					/* ubNŏIL[ */
					key = bufp - ihp->lRec + 8;
				} else {
					/* L[폜 */
					memcpy(bufp, bufp + ihp->lRec
					, ihp->lRec * (m - bp->cp - 1) + 4);
					loopSw = FALSE;
				}
				(*(SHORT *)bp->block)--;
			}
				
			IDXWrite(ip, bp);
		} else {
			if (bp->cp != m) {
				/* ʃubÑL[ւ */
				memcpy(bufp + 8, key, ihp->lKey);
				IDXWrite(ip, bp);
				loopSw = FALSE;
			}
		}
		bp = bp->bwp;
	}
}

/*=======================================================================
 |
 |		R[hԍo
 |
 |	LONG	IDXNext(ip)
 |
 |		IDX	*ip;		hcw|C^
 |
 |		Ԓl			R[hԍ
 |
 =======================================================================*/
LONG	IDXNext(IDX *ip)
{
	CHAR	*bufp;
	SHORT	m;
	LONG	bno;
	LONG	rno;
	IDX_H	*ihp;
	IDX_B	*bp;

	ihp = ip->ihp;
	for (;;) {
		if ((bp = ip->bp) == NULL)
			break;
		bp->cp++;		/* Jg|C^XV */
		bufp = bp->block;
		m = *(SHORT *)bufp;	/* ubNf[^o */

		bufp += 4 + bp->cp * ihp->lRec;
		for (; bp->cp < m; bp->cp++) {
			if ((rno = *(LONG *)(bufp+4)) != 0) {
				ip->keyp = bufp + 8;
				return(rno);
			}
			if (*(LONG *)bufp != 0)
				break;
			bufp += ihp->lRec;
		}

		if (bp->cp <= m && (bno = *(LONG *)bufp) != 0) {
			/* ʃubNǂݍ */
			bp = IDXRead(ip, bno);
			bp->cp = -1;
		} else {
			/* ʃubN|C^Zbg */
			ip->bp = bp->bwp;
		}
	}
	return(0L);
}

/*=======================================================================
 |
 |		OR[hԍo
 |
 |	LONG	IDXBack(ip)
 |
 |		IDX	*ip;		hcw|C^
 |
 |		Ԓl			R[hԍ
 |
 =======================================================================*/
LONG	IDXBack(IDX *ip)
{
	CHAR	*bufp;
	SHORT	m;
	LONG	bno;
	LONG	rno;
	IDX_H	*ihp;
	IDX_B	*bp;

	ihp = ip->ihp;
	for (;;) {
		if ((bp = ip->bp) == NULL)
			break;
		bp->cp--;		/* Jg|C^XV */
		bufp = bp->block;
		m = *(SHORT *)bufp;	/* ubNf[^o */

		bufp += 4 + bp->cp * ihp->lRec;
		for (; bp->cp >= 0; bp->cp--) {
			if (bp->cp < m) {
				if ((rno = *(LONG *)(bufp+4)) != 0) {
					ip->keyp = bufp + 8;
					return(rno);
				}
			}
			if (*(LONG *)bufp != 0)
				break;
			bufp -= ihp->lRec;
		}

		if (bp->cp >= 0 && (bno = *(LONG *)bufp) != 0) {
			/* ʃubNǂݍ */
			bp = IDXRead(ip, bno);
			bp->cp = *(SHORT *)bp->block + 1;
		} else {
			/* ʃubN|C^Zbg */
			ip->bp = bp->bwp;
		}
	}
	return(0L);
}

/*=======================================================================
 |
 |		擪R[hԍo
 |
 |	LONG	IDXTop(ip)
 |
 |		IDX	*ip;		hcw|C^
 |
 |		Ԓl			R[hԍ
 |
 =======================================================================*/
LONG	IDXTop(IDX *ip)
{
	IDX_B	*bp;
	CHAR	*bufp;
	LONG	bno;

	ip->bp = NULL;		/* ubN|C^ */

	bno = ip->ihp->root;	/* [gubNԍZbg */
	for (;;) {
		bp = IDXRead(ip, bno);	/* ubNf[^ǂݍ */

		bufp = bp->block;

		bp->cp = 0;	/* Jg|C^NA */

		bufp += 4;
		if ((bno = *(LONG *)bufp) == 0)
			break;
	}

	ip->keyp = bufp + 8;
	return(*(LONG *)(bufp + 4));
}

/*=======================================================================
 |
 |		ŏIR[hԍo
 |
 |	LONG	IDXBottom(ip)
 |
 |		IDX	*ip;		hcw|C^
 |
 |		Ԓl			R[hԍ
 |
 =======================================================================*/
LONG	IDXBottom(IDX *ip)
{
	IDX_B	*bp;
	CHAR	*bufp;
	LONG	bno;

	ip->bp = NULL;		/* ubN|C^ */

	bno = ip->ihp->root;	/* [gubNԍZbg */
	for (;;) {
		bp = IDXRead(ip, bno);	/* ubNf[^ǂݍ */

		bufp = bp->block;

		bp->cp = *(SHORT *)bufp;	/* Jg|C^Zbg */

		bufp += 4 + bp->cp * ip->ihp->lRec;
		if ((bno = *(LONG *)bufp) == 0)
			break;
	}

	bp->cp--;
	bufp -= ip->ihp->lRec;
	
	ip->keyp = bufp + 8;
	return(*(LONG *)(bufp + 4));
}

/*=======================================================================
 |
 |		vL[̌߂
 |
 |	LONG	IDXCount(ip, key, len)
 |
 |		IDX	*ip;		hcw|C^
 |		CHAR	*key;		镶
 |		SHORT	len;		镶̒
 |
 |		Ԓl			vL[̌
 |
 =======================================================================*/
LONG	IDXCount(IDX *ip, VOID *key, SHORT len)
{
	IDX_H	*ihp;
	LONG	count;

	ihp = ip->ihp;
	count = 0;
	if (IDXSearch(ip, key, len) != 0) {
		for (;;) {
			count++;
			if (IDXNext(ip) == 0) {
				IDXBottom(ip);
				ip->bp->cp++;
				break;
			}
			if (IDXCompare(ip, key, len) != 0)
				break;
		}
	}
	return(count);
}

static	USHORT	Marge(int fh1, int fh2, SORTBLK *sbp1
		, SORTBLK *sbp2, CHAR *bufp, USHORT lRec
		, SHORT (*comp)(CHAR *, CHAR *))
{
	USHORT	nRec;
	USHORT	n1, n2, n3;
	LONG	offset1, offset2;
	CHAR	*buf1, *buf2, *buf3;
	CHAR	*p1, *p2, *p3;
	LONG	nRec1, nRec2;
	LONG	rec;

	nRec = MBLOCK / lRec;
	n1 = n2 = n3 = 0;
	nRec1 = sbp1->nRec;
	nRec2 = sbp2->nRec;
	offset1 = sbp1->offset;
	offset2 = sbp2->offset;
	buf1 = bufp;
	buf2 = buf1 + MBLOCK;
	buf3 = buf2 + MBLOCK;

	p3 = buf3;
	rec = nRec1 + nRec2;
	while (rec--) {
		if (n1 == 0 && nRec1 != 0) {
			n1 = (USHORT)min((LONG)nRec, nRec1);
			nRec1 -= n1;
			lseek(fh1, offset1, SEEK_SET);
			if (read(fh1, buf1, lRec * n1) != (int)(lRec * n1)) {
				DBErr(IE_READ);
				return(1);
			}
			offset1 += lRec * n1;
			p1 = buf1;
		}
		if (n2 == 0 && nRec2 != 0) {
			n2 = (USHORT)min((LONG)nRec, nRec2);
			nRec2 -= n2;
			lseek(fh1, offset2, SEEK_SET);
			if (read(fh1, buf2, lRec * n2) != (int)(lRec * n2)) {
				DBErr(IE_READ);
				return(1);
			}
			offset2 += lRec * n2;
			p2 = buf2;
		}

		if (n1 != 0 && (n2 == 0 || (*comp)(p1, p2) <= 0)) {
			memcpy(p3, p1, lRec);
			p1 += lRec;
			n1--;
		} else {
			memcpy(p3, p2, lRec);
			p2 += lRec;
			n2--;
		}

		p3 += lRec;
		if (++n3 == nRec) {
			if (write(fh2, buf3, lRec * n3) != (int)(lRec * n3)) {
				DBErr(IE_WRITE);
				return(1);
			}
			p3 = buf3;
			n3 = 0;
		}
	}
	if (write(fh2, buf3, lRec * n3) != (int)(lRec * n3)) {
		DBErr(IE_WRITE);
		return(1);
	}
	return(0);
}

/*=======================================================================
 |
 |		CfbNXt@C\z
 |
 |	VOID	IDXMake(dp, ip)
 |
 |		DBF	*dp;		cae|C^
 |		IDX	*ip;		hcw|C^
 |
 =======================================================================*/
VOID	IDXMake(DBF *dp, IDX *ip)
{
	FIELD	*flp;
	int	fh[2];
	DBF_H	*dhp;
	IDX_H	*ihp;
	SORTBLK *sbp;
	USHORT	nRec, lRec, nBlock, block, block1, block2, n;
	USHORT	type, klen;
	CHAR	*bufp;
	CHAR	tmpFile[2][80];
	USHORT	tmp, tmp1, tmp2;
	LONG	rec;
	USHORT	i;
	CHAR	*p;
	CHAR	kbuf[100];
	SHORT	(*comp)();

	fh[0] = fh[1] = -1;
	bufp = NULL;
	sbp = NULL;

	ihp = ip->ihp;

	/* L[`FbN */
	strcpy(kbuf, ihp->index);
	p = strtok(kbuf, "+ ");
	type = -1;
	klen = 0;
	while (p) {
		if ((flp = GetField(dp, p)) != NULL) {
			switch (flp->type) {
			case 'C':
				if (type == 1) {
					DBErr(IE_IDXKEY);
					return;
				}
				type = 0;
				klen += flp->lField;
				break;
			case 'D':
				if (type == 1) {
					DBErr(IE_IDXKEY);
					return;
				}
				type = 0;
				klen += 8;
				break;
			default:
				DBErr(IE_IDXKEY);
				return;
			}
		} else {
			DBErr(IE_IDXKEY);
			return;
		}

		p = strtok(NULL, "+ ");
	}

	IDXSetInfo(ip, type, klen);	/* CfbNXZbg */

	compLength = klen;

	strcpy(tmpFile[0], ip->fileName);
	SetExt(tmpFile[0], "$$1");
	if ((fh[0] = open(tmpFile[0], O_BINARY|O_RDWR|O_CREAT,
						S_IREAD|S_IWRITE)) == -1) {
		DBErr(IE_TMPFILE);
		return;
	}

	strcpy(tmpFile[1], ip->fileName);
	SetExt(tmpFile[1], "$$2");
	if ((fh[1] = open(tmpFile[1], O_BINARY|O_RDWR|O_CREAT,
						S_IREAD|S_IWRITE)) == -1) {
		DBErr(IE_TMPFILE);
		goto ret;
	}

	dhp = dp->dhp;

	comp = Comp2;
	lRec = klen + 4;
	nRec = SBLOCK / lRec;
	nBlock = (USHORT)((dhp->nRec - 1) / nRec + 1);
	if ((sbp = calloc(nBlock, sizeof(SORTBLK))) == NULL) {
		DBErr(IE_MEMORY);
		goto ret;
	}

	if ((bufp = malloc(SBLOCK)) == NULL) {
		DBErr(IE_MEMORY);
		goto ret;
	}

	rec = 0;
	lseek(dp->fh, (LONG)dhp->lHeader, SEEK_SET);
	for (block = 0; block < nBlock; block++) {
		n  = (USHORT)min((LONG)nRec, dhp->nRec - rec);
		sbp[block].nRec = n;
		sbp[block].offset = lRec * rec;
		for (i = 0, p = bufp; i < n; i++, p += lRec) {
			if (read(dp->fh, dp->rbp, dhp->lRec) !=
							(int)dhp->lRec) {
				DBErr(IE_READ);
				goto ret;
			}
			*(LONG *)p = ++rec;
			GetKey(dp, ihp, p+4);
		}
		qsort(bufp, n, lRec, comp);
		if (write(fh[0], bufp, lRec * n) != (int)(lRec * n)) {
			DBErr(IE_WRITE);
			goto ret;
		}
	}
	dp->rno = 0;

	tmp1 = 0;
	tmp2 = 1;
	for ( ; nBlock != 1; nBlock = (nBlock + 1) / 2) {
		lseek(fh[tmp2], 0L, SEEK_SET);

		for (block = 0; block < nBlock/2; block++) {
			block1 = block * 2;
			block2 = block1 + 1;
			if (Marge(fh[tmp1], fh[tmp2], &sbp[block1], &sbp[block2], bufp, lRec, comp) != 0)
				goto ret;
			sbp[block].nRec = sbp[block1].nRec
						+ sbp[block2].nRec;
			sbp[block].offset = sbp[block1].offset;
		}
		if (nBlock % 2 != 0) {
			block1 = block * 2;
			lseek(fh[tmp1], sbp[block1].offset, SEEK_SET);
			for (rec = sbp[block1].nRec; rec != 0; ) {
				n = (USHORT)min((LONG)nRec, rec);
				if (read(fh[tmp1], bufp, lRec * n) !=
							(int)(lRec * n)) {
					DBErr(IE_READ);
					goto ret;
				}
				if (write(fh[tmp2], bufp, lRec * n) !=
							(int)(lRec * n)) {
					DBErr(IE_WRITE);
					goto ret;
				}
				rec -= n;
			}
			sbp[block].nRec = sbp[block1].nRec;
			sbp[block].offset = sbp[block1].offset;
		}
		tmp = tmp1;
		tmp1 = tmp2;
		tmp2 = tmp;
	}

	lseek(fh[tmp1], 0L, SEEK_SET);
	WrtIndex(ip, fh[tmp1], dhp->nRec, lRec);
ret:
	if (bufp)
		free(bufp);
	if (sbp)
		free(sbp);

	if (fh[1] != -1) {
		close(fh[1]);
		remove(tmpFile[1]);
	}
	if (fh[0] != -1) {
		close(fh[0]);
		remove(tmpFile[0]);
	}
}

static	SHORT	Comp2(CHAR *p1, CHAR *p2)
{
	SHORT	i;
	LONG	l;

	if ((i = memcmp(p1+4, p2+4, compLength)) == 0) {
		l = *(LONG *)p1 - *(LONG *)p2;
		i = (l == 0) ? 0 : (l < 0) ? -1 : 1;
	}
	return(i);
}

static	VOID	WrtIndex(IDX *ip, int fh, LONG nRec, SHORT lRec)
{
	IDX_H	*ihp;
	LONG	bno;
	SHORT	level;
	CHAR	key[100];

	chsize(ip->fh, 0L);

	ihp = ip->ihp;

	memset(key, 0, ihp->lKey);
	wnRec = nRec;
	wBno = 1;
	level = 0;
	do {
		ip->bp = NULL;
		WrtBlock(ip, fh, level++, lRec, key, &bno);
	} while (wnRec != 0);

	ihp->root = bno;
	ihp->nBlock = wBno;
	ip->wFlag = TRUE;
}

static	VOID	WrtBlock(IDX *ip, int fh, SHORT level, SHORT lRec, CHAR *key
		, LONG *bno)
{
	IDX_H	*ihp;
	IDX_B	*bp;
	CHAR	*bufp;
	USHORT	i;

	ihp = ip->ihp;
	bp = IDXRead(ip, 0L);
	bufp = bp->block + 4;

	if (level == 0) {
		for (i = 0; i < ihp->order && wnRec != 0; wnRec--) {
			if (read(fh, bufp + 4, lRec) != lRec) {
				DBErr(IE_READ);
				return;
			}
			if (ihp->uniq) {
				if (memcmp(bufp + 8, key, ihp->lKey) == 0)
					continue;
			}
			*(LONG *)bufp = 0;
			memcpy(key, bufp + 8, ihp->lKey);
			bufp += ihp->lRec;
			i++;
		}
		*(LONG *)bufp = 0;
	} else {
		if (*bno == 0)
			WrtBlock(ip, fh, level-1, lRec, key, bno);

		for (i = 0; i < ihp->order && wnRec != 0; i++) {
			*(LONG *)bufp = *bno;
			*(LONG *)(bufp+4) = 0;
			memcpy(bufp+8, key, ihp->lKey);
			*bno = 0;
			WrtBlock(ip, fh, level-1, lRec, key, bno);
			bufp += ihp->lRec;
		}
		*(LONG *)bufp = *bno;
	}

	*(SHORT *)bp->block = i;
	bp->bno = wBno++;
	IDXWrite(ip, bp);
	*bno = bp->bno;
	ip->bp = bp->bwp;
}

static	VOID	SetExt(CHAR *name, CHAR *ext)
{
	CHAR	 *p;

	if ((p = strrchr(name, '.')) != NULL)
		strcpy(p+1, ext);
	else {
		strcat(name, ".");
		strcat(name, ext);
	}
}


/*=======================================================================
 |
 |		R[ho
 |
 |	LONG	DBRecCount(dbp)
 |
 |		DB	*dbp;		ca|C^
 |
 |		Ԓl			R[h
 |
 =======================================================================*/
LONG	DBRecCount(DB *dbp)
{
	return(dbp->dp->dhp->nRec);
}

/*=======================================================================
 |
 |		ane`FbN
 |
 |	BOOL	DBBof(dbp)
 |
 |		DB	*dbp;		ca|C^
 |
 |		BOOL	Ԓl		TRUE Fane
 |					FALSEFanełȂ
 |
 =======================================================================*/
BOOL	DBBof(DB *dbp)
{
	return(dbp->bof);
}

/*=======================================================================
 |
 |		dne`FbN
 |
 |	BOOL	DBEof(dbp)
 |
 |		DB	*dbp;		ca|C^
 |
 |		BOOL	Ԓl		TRUE Fdne
 |					FALSEFdnełȂ
 |
 =======================================================================*/
BOOL	DBEof(DB *dbp)
{
	return(dbp->eof);
}

/*=======================================================================
 |
 |		JgR[hԍo
 |
 |	LONG	DBRecNo(dbp)
 |
 |		DB	*dbp;		ca|C^
 |
 |		Ԓl			JgR[hԍ
 |
 =======================================================================*/
LONG	DBRecNo(DB *dbp)
{
	return(dbp->rno);
}

/*=======================================================================
 |
 |		폜R[h[hݒ
 |
 |	VOID	SetDeleted(flag)
 |
 |		BOOL	flag;		FALSEF폜R[hL
 |					TRUE F폜R[h
 |
 =======================================================================*/
VOID	SetDeleted(BOOL flag)
{
	_dbSetDeleted = flag;
}


/*=======================================================================
 |
 |		G[nhݒ
 |
 |	VOID	DBErrHandler(func)
 |
 |		VOID	(*func)(SHORT);	G[֐ւ̃|C^
 |
 =======================================================================*/
VOID	DBErrHandler(VOID (*func)(SHORT))
{
	_dbErrHandler = func;
}

/*=======================================================================
 |
 |		G[
 |
 |	VOID	DBErr(errCode)
 |
 |		SHORT	errCode;	G[R[h
 |
 =======================================================================*/
VOID	DBErr(SHORT errCode)
{
	_dbErrCode = errCode;

	if (_dbErrHandler != NULL) {
		/* G[nhݒ肳ĂĂяo */
		(*_dbErrHandler)(errCode);
	}
}

/*=======================================================================
 |
 |		񂩂琮ւ̕ϊ
 |
 |	SHORT	natoi(str, len)
 |
 |		CHAR	*str;		
 |		SHORT	len;		
 |
 |		Ԓl			l
 |
 =======================================================================*/
SHORT	natoi(CHAR *str, SHORT len)
{
	CHAR	buf[32];

	memcpy(buf, str, len);
	buf[len] = '\0';
	return(atoi(buf));
}

/*=======================================================================
 |
 |		L[o
 |
 |	SHORT	GetKey(dp, ihp, kp)
 |
 |		DBF	*dp;		cae|C^
 |		IDX_H	*ihp;		hcwQg|C^
 |		CHAR	*kp;		L[obt@
 |
 |		Ԓl			OFL[Ȃ@PFL[
 |
 =======================================================================*/
SHORT	GetKey(DBF *dp, IDX_H *ihp, CHAR *kp)
{
	FIELD	*flp;
	CHAR	buf[100], *p;
	SHORT	flag;

	strcpy(buf, ihp->index);
	p = strtok(buf, "+ ");
	*kp = '\0';
	flag = 0;
	while (p) {
		if ((flp = GetField(dp, p)) != NULL) {
			memcpy(kp, flp->fad, flp->lField);
			kp += flp->lField;
			flag = 1;
		} else
			return(0);

		p = strtok(NULL, "+ ");
	}

	return(flag);
}

/*=======================================================================
 |
 |		tB[ho
 |
 |	FIELD	*GetField(dp, field)
 |
 |		DBF	*dp;		cae|C^
 |		CHAR	*field;		tB[h
 |
 |		Ԓl			tB[hւ̃|C^
 |
 =======================================================================*/
FIELD	*GetField(DBF *dp, CHAR *field)
{
	USHORT	i;
	FIELD	*flp;

	for (i = 0, flp = dp->flp; i < dp->nField; i++, flp++) {
		if (strcmp(field, flp->name) == 0)
			return(flp);
	}
	return(NULL);
}
